<?php
/**
 * Countries
 *
 * Returns an array of countries and codes.
 */

if ( ! defined('ABSPATH')) {
    exit;
}

switch ($country_type) {
    case 'alpha-3':
        return array(
            'AFG' => __('Afghanistan', 'mailoptin'),
            'ALA' => __('&#197;land Islands', 'mailoptin'),
            'ALB' => __('Albania', 'mailoptin'),
            'DZA' => __('Algeria', 'mailoptin'),
            'ASM' => __('American Samoa', 'mailoptin'),
            'AND' => __('Andorra', 'mailoptin'),
            'AGO' => __('Angola', 'mailoptin'),
            'AIA' => __('Anguilla', 'mailoptin'),
            'ATA' => __('Antarctica', 'mailoptin'),
            'ATG' => __('Antigua and Barbuda', 'mailoptin'),
            'ARG' => __('Argentina', 'mailoptin'),
            'ARM' => __('Armenia', 'mailoptin'),
            'ABW' => __('Aruba', 'mailoptin'),
            'AUS' => __('Australia', 'mailoptin'),
            'AUT' => __('Austria', 'mailoptin'),
            'AZE' => __('Azerbaijan', 'mailoptin'),
            'BHS' => __('Bahamas', 'mailoptin'),
            'BHR' => __('Bahrain', 'mailoptin'),
            'BGD' => __('Bangladesh', 'mailoptin'),
            'BRB' => __('Barbados', 'mailoptin'),
            'BLR' => __('Belarus', 'mailoptin'),
            'BEL' => __('Belgium', 'mailoptin'),
            'PLW' => __('Belau', 'mailoptin'),
            'BLZ' => __('Belize', 'mailoptin'),
            'BEN' => __('Benin', 'mailoptin'),
            'BMU' => __('Bermuda', 'mailoptin'),
            'BTN' => __('Bhutan', 'mailoptin'),
            'BOL' => __('Bolivia', 'mailoptin'),
            'BES' => __('Bonaire, Saint Eustatius and Saba', 'mailoptin'),
            'BIH' => __('Bosnia and Herzegovina', 'mailoptin'),
            'BWA' => __('Botswana', 'mailoptin'),
            'BVT' => __('Bouvet Island', 'mailoptin'),
            'BRA' => __('Brazil', 'mailoptin'),
            'IOT' => __('British Indian Ocean Territory', 'mailoptin'),
            'BRN' => __('Brunei', 'mailoptin'),
            'BGR' => __('Bulgaria', 'mailoptin'),
            'BFA' => __('Burkina Faso', 'mailoptin'),
            'BDI' => __('Burundi', 'mailoptin'),
            'CPV' => __('Cabo Verde', 'mailoptin'),
            'KHM' => __('Cambodia', 'mailoptin'),
            'CMR' => __('Cameroon', 'mailoptin'),
            'CAN' => __('Canada', 'mailoptin'),
            'CYM' => __('Cayman Islands', 'mailoptin'),
            'CAF' => __('Central African Republic', 'mailoptin'),
            'TCD' => __('Chad', 'mailoptin'),
            'CHL' => __('Chile', 'mailoptin'),
            'CHN' => __('China', 'mailoptin'),
            'CXR' => __('Christmas Island', 'mailoptin'),
            'CCK' => __('Cocos (Keeling) Islands', 'mailoptin'),
            'COL' => __('Colombia', 'mailoptin'),
            'COM' => __('Comoros', 'mailoptin'),
            'COG' => __('Congo (Brazzaville)', 'mailoptin'),
            'COD' => __('Congo (Kinshasa)', 'mailoptin'),
            'COK' => __('Cook Islands', 'mailoptin'),
            'CRI' => __('Costa Rica', 'mailoptin'),
            'HRV' => __('Croatia', 'mailoptin'),
            'CUB' => __('Cuba', 'mailoptin'),
            'CUW' => __('Cura&ccedil;ao', 'mailoptin'),
            'CYP' => __('Cyprus', 'mailoptin'),
            'CZE' => __('Czech Republic', 'mailoptin'),
            'DNK' => __('Denmark', 'mailoptin'),
            'DJI' => __('Djibouti', 'mailoptin'),
            'DMA' => __('Dominica', 'mailoptin'),
            'DOM' => __('Dominican Republic', 'mailoptin'),
            'ECU' => __('Ecuador', 'mailoptin'),
            'EGY' => __('Egypt', 'mailoptin'),
            'SLV' => __('El Salvador', 'mailoptin'),
            'GNQ' => __('Equatorial Guinea', 'mailoptin'),
            'ERI' => __('Eritrea', 'mailoptin'),
            'EST' => __('Estonia', 'mailoptin'),
            'SWZ' => __('Eswatini', 'mailoptin'),
            'ETH' => __('Ethiopia', 'mailoptin'),
            'FLK' => __('Falkland Islands', 'mailoptin'),
            'FRO' => __('Faroe Islands', 'mailoptin'),
            'FJI' => __('Fiji', 'mailoptin'),
            'FIN' => __('Finland', 'mailoptin'),
            'FRA' => __('France', 'mailoptin'),
            'GUF' => __('French Guiana', 'mailoptin'),
            'PYF' => __('French Polynesia', 'mailoptin'),
            'ATF' => __('French Southern Territories', 'mailoptin'),
            'GAB' => __('Gabon', 'mailoptin'),
            'GMB' => __('Gambia', 'mailoptin'),
            'GEO' => __('Georgia', 'mailoptin'),
            'DEU' => __('Germany', 'mailoptin'),
            'GHA' => __('Ghana', 'mailoptin'),
            'GIB' => __('Gibraltar', 'mailoptin'),
            'GRC' => __('Greece', 'mailoptin'),
            'GRL' => __('Greenland', 'mailoptin'),
            'GRD' => __('Grenada', 'mailoptin'),
            'GLP' => __('Guadeloupe', 'mailoptin'),
            'GUM' => __('Guam', 'mailoptin'),
            'GTM' => __('Guatemala', 'mailoptin'),
            'GGY' => __('Guernsey', 'mailoptin'),
            'GIN' => __('Guinea', 'mailoptin'),
            'GNB' => __('Guinea-Bissau', 'mailoptin'),
            'GUY' => __('Guyana', 'mailoptin'),
            'HTI' => __('Haiti', 'mailoptin'),
            'HMD' => __('Heard Island and McDonald Islands', 'mailoptin'),
            'HND' => __('Honduras', 'mailoptin'),
            'HKG' => __('Hong Kong', 'mailoptin'),
            'HUN' => __('Hungary', 'mailoptin'),
            'ISL' => __('Iceland', 'mailoptin'),
            'IND' => __('India', 'mailoptin'),
            'IDN' => __('Indonesia', 'mailoptin'),
            'IRN' => __('Iran', 'mailoptin'),
            'IRQ' => __('Iraq', 'mailoptin'),
            'IRL' => __('Ireland', 'mailoptin'),
            'IMN' => __('Isle of Man', 'mailoptin'),
            'ISR' => __('Israel', 'mailoptin'),
            'ITA' => __('Italy', 'mailoptin'),
            'CIV' => __('Ivory Coast', 'mailoptin'),
            'JAM' => __('Jamaica', 'mailoptin'),
            'JPN' => __('Japan', 'mailoptin'),
            'JEY' => __('Jersey', 'mailoptin'),
            'JOR' => __('Jordan', 'mailoptin'),
            'KAZ' => __('Kazakhstan', 'mailoptin'),
            'KEN' => __('Kenya', 'mailoptin'),
            'KIR' => __('Kiribati', 'mailoptin'),
            'KWT' => __('Kuwait', 'mailoptin'),
            'KGZ' => __('Kyrgyzstan', 'mailoptin'),
            'LAO' => __('Laos', 'mailoptin'),
            'LVA' => __('Latvia', 'mailoptin'),
            'LBN' => __('Lebanon', 'mailoptin'),
            'LSO' => __('Lesotho', 'mailoptin'),
            'LBR' => __('Liberia', 'mailoptin'),
            'LBY' => __('Libya', 'mailoptin'),
            'LIE' => __('Liechtenstein', 'mailoptin'),
            'LTU' => __('Lithuania', 'mailoptin'),
            'LUX' => __('Luxembourg', 'mailoptin'),
            'MAC' => __('Macao', 'mailoptin'),
            'MKD' => __('North Macedonia', 'mailoptin'),
            'MDG' => __('Madagascar', 'mailoptin'),
            'MWI' => __('Malawi', 'mailoptin'),
            'MYS' => __('Malaysia', 'mailoptin'),
            'MDV' => __('Maldives', 'mailoptin'),
            'MLI' => __('Mali', 'mailoptin'),
            'MLT' => __('Malta', 'mailoptin'),
            'MHL' => __('Marshall Islands', 'mailoptin'),
            'MTQ' => __('Martinique', 'mailoptin'),
            'MRT' => __('Mauritania', 'mailoptin'),
            'MUS' => __('Mauritius', 'mailoptin'),
            'MYT' => __('Mayotte', 'mailoptin'),
            'MEX' => __('Mexico', 'mailoptin'),
            'FSM' => __('Micronesia', 'mailoptin'),
            'MDA' => __('Moldova', 'mailoptin'),
            'MCO' => __('Monaco', 'mailoptin'),
            'MNG' => __('Mongolia', 'mailoptin'),
            'MNE' => __('Montenegro', 'mailoptin'),
            'MSR' => __('Montserrat', 'mailoptin'),
            'MAR' => __('Morocco', 'mailoptin'),
            'MOZ' => __('Mozambique', 'mailoptin'),
            'MMR' => __('Myanmar', 'mailoptin'),
            'NAM' => __('Namibia', 'mailoptin'),
            'NRU' => __('Nauru', 'mailoptin'),
            'NPL' => __('Nepal', 'mailoptin'),
            'NLD' => __('Netherlands', 'mailoptin'),
            'NCL' => __('New Caledonia', 'mailoptin'),
            'NZL' => __('New Zealand', 'mailoptin'),
            'NIC' => __('Nicaragua', 'mailoptin'),
            'NER' => __('Niger', 'mailoptin'),
            'NGA' => __('Nigeria', 'mailoptin'),
            'NIU' => __('Niue', 'mailoptin'),
            'NFK' => __('Norfolk Island', 'mailoptin'),
            'MNP' => __('Northern Mariana Islands', 'mailoptin'),
            'PRK' => __('North Korea', 'mailoptin'),
            'NOR' => __('Norway', 'mailoptin'),
            'OMN' => __('Oman', 'mailoptin'),
            'PAK' => __('Pakistan', 'mailoptin'),
            'PSE' => __('Palestinian Territory', 'mailoptin'),
            'PAN' => __('Panama', 'mailoptin'),
            'PNG' => __('Papua New Guinea', 'mailoptin'),
            'PRY' => __('Paraguay', 'mailoptin'),
            'PER' => __('Peru', 'mailoptin'),
            'PHL' => __('Philippines', 'mailoptin'),
            'PCN' => __('Pitcairn', 'mailoptin'),
            'POL' => __('Poland', 'mailoptin'),
            'PRT' => __('Portugal', 'mailoptin'),
            'PRI' => __('Puerto Rico', 'mailoptin'),
            'QAT' => __('Qatar', 'mailoptin'),
            'REU' => __('Reunion', 'mailoptin'),
            'ROU' => __('Romania', 'mailoptin'),
            'RUS' => __('Russia', 'mailoptin'),
            'RWA' => __('Rwanda', 'mailoptin'),
            'BLM' => __('Saint Barth&eacute;lemy', 'mailoptin'),
            'SHN' => __('Saint Helena', 'mailoptin'),
            'KNA' => __('Saint Kitts and Nevis', 'mailoptin'),
            'LCA' => __('Saint Lucia', 'mailoptin'),
            'MAF' => __('Saint Martin (French part)', 'mailoptin'),
            'SXM' => __('Sint Maarten (Dutch part)', 'mailoptin'),
            'SPM' => __('Saint Pierre and Miquelon', 'mailoptin'),
            'VCT' => __('Saint Vincent and the Grenadines', 'mailoptin'),
            'SMR' => __('San Marino', 'mailoptin'),
            'STP' => __('S&atilde;o Tom&eacute; and Pr&iacute;ncipe', 'mailoptin'),
            'SAU' => __('Saudi Arabia', 'mailoptin'),
            'SEN' => __('Senegal', 'mailoptin'),
            'SRB' => __('Serbia', 'mailoptin'),
            'SYC' => __('Seychelles', 'mailoptin'),
            'SLE' => __('Sierra Leone', 'mailoptin'),
            'SGP' => __('Singapore', 'mailoptin'),
            'SVK' => __('Slovakia', 'mailoptin'),
            'SVN' => __('Slovenia', 'mailoptin'),
            'SLB' => __('Solomon Islands', 'mailoptin'),
            'SOM' => __('Somalia', 'mailoptin'),
            'ZAF' => __('South Africa', 'mailoptin'),
            'SGS' => __('South Georgia/Sandwich Islands', 'mailoptin'),
            'KOR' => __('South Korea', 'mailoptin'),
            'SSD' => __('South Sudan', 'mailoptin'),
            'ESP' => __('Spain', 'mailoptin'),
            'LKA' => __('Sri Lanka', 'mailoptin'),
            'SDN' => __('Sudan', 'mailoptin'),
            'SUR' => __('Suriname', 'mailoptin'),
            'SJM' => __('Svalbard and Jan Mayen', 'mailoptin'),
            'SWZ' => __('Swaziland', 'mailoptin'),
            'SWE' => __('Sweden', 'mailoptin'),
            'CHE' => __('Switzerland', 'mailoptin'),
            'SYR' => __('Syria', 'mailoptin'),
            'TWN' => __('Taiwan', 'mailoptin'),
            'TJK' => __('Tajikistan', 'mailoptin'),
            'TZA' => __('Tanzania', 'mailoptin'),
            'THA' => __('Thailand', 'mailoptin'),
            'TLS' => __('Timor-Leste', 'mailoptin'),
            'TGO' => __('Togo', 'mailoptin'),
            'TKL' => __('Tokelau', 'mailoptin'),
            'TON' => __('Tonga', 'mailoptin'),
            'TTO' => __('Trinidad and Tobago', 'mailoptin'),
            'TUN' => __('Tunisia', 'mailoptin'),
            'TUR' => __('Turkey', 'mailoptin'),
            'TKM' => __('Turkmenistan', 'mailoptin'),
            'TCA' => __('Turks and Caicos Islands', 'mailoptin'),
            'TUV' => __('Tuvalu', 'mailoptin'),
            'UGA' => __('Uganda', 'mailoptin'),
            'UKR' => __('Ukraine', 'mailoptin'),
            'ARE' => __('United Arab Emirates', 'mailoptin'),
            'GBR' => __('United Kingdom (UK)', 'mailoptin'),
            'USA' => __('United States (US)', 'mailoptin'),
            'UMI' => __('United States (US) Minor Outlying Islands', 'mailoptin'),
            'URY' => __('Uruguay', 'mailoptin'),
            'UZB' => __('Uzbekistan', 'mailoptin'),
            'VUT' => __('Vanuatu', 'mailoptin'),
            'VAT' => __('Vatican', 'mailoptin'),
            'VEN' => __('Venezuela', 'mailoptin'),
            'VNM' => __('Vietnam', 'mailoptin'),
            'VGB' => __('Virgin Islands (British)', 'mailoptin'),
            'VIR' => __('Virgin Islands (US)', 'mailoptin'),
            'WLF' => __('Wallis and Futuna', 'mailoptin'),
            'ESH' => __('Western Sahara', 'mailoptin'),
            'WSM' => __('Samoa', 'mailoptin'),
            'YEM' => __('Yemen', 'mailoptin'),
            'ZMB' => __('Zambia', 'mailoptin'),
            'ZWE' => __('Zimbabwe', 'mailoptin'),
        );
        break;
    default:
        return array(
            'AF' => __('Afghanistan', 'mailoptin'),
            'AX' => __('&#197;land Islands', 'mailoptin'),
            'AL' => __('Albania', 'mailoptin'),
            'DZ' => __('Algeria', 'mailoptin'),
            'AS' => __('American Samoa', 'mailoptin'),
            'AD' => __('Andorra', 'mailoptin'),
            'AO' => __('Angola', 'mailoptin'),
            'AI' => __('Anguilla', 'mailoptin'),
            'AQ' => __('Antarctica', 'mailoptin'),
            'AG' => __('Antigua and Barbuda', 'mailoptin'),
            'AR' => __('Argentina', 'mailoptin'),
            'AM' => __('Armenia', 'mailoptin'),
            'AW' => __('Aruba', 'mailoptin'),
            'AU' => __('Australia', 'mailoptin'),
            'AT' => __('Austria', 'mailoptin'),
            'AZ' => __('Azerbaijan', 'mailoptin'),
            'BS' => __('Bahamas', 'mailoptin'),
            'BH' => __('Bahrain', 'mailoptin'),
            'BD' => __('Bangladesh', 'mailoptin'),
            'BB' => __('Barbados', 'mailoptin'),
            'BY' => __('Belarus', 'mailoptin'),
            'BE' => __('Belgium', 'mailoptin'),
            'PW' => __('Belau', 'mailoptin'),
            'BZ' => __('Belize', 'mailoptin'),
            'BJ' => __('Benin', 'mailoptin'),
            'BM' => __('Bermuda', 'mailoptin'),
            'BT' => __('Bhutan', 'mailoptin'),
            'BO' => __('Bolivia', 'mailoptin'),
            'BQ' => __('Bonaire, Saint Eustatius and Saba', 'mailoptin'),
            'BA' => __('Bosnia and Herzegovina', 'mailoptin'),
            'BW' => __('Botswana', 'mailoptin'),
            'BV' => __('Bouvet Island', 'mailoptin'),
            'BR' => __('Brazil', 'mailoptin'),
            'IO' => __('British Indian Ocean Territory', 'mailoptin'),
            'BN' => __('Brunei', 'mailoptin'),
            'BG' => __('Bulgaria', 'mailoptin'),
            'BF' => __('Burkina Faso', 'mailoptin'),
            'BI' => __('Burundi', 'mailoptin'),
            'CV' => __('Cabo Verde', 'mailoptin'),
            'KH' => __('Cambodia', 'mailoptin'),
            'CM' => __('Cameroon', 'mailoptin'),
            'CA' => __('Canada', 'mailoptin'),
            'KY' => __('Cayman Islands', 'mailoptin'),
            'CF' => __('Central African Republic', 'mailoptin'),
            'TD' => __('Chad', 'mailoptin'),
            'CL' => __('Chile', 'mailoptin'),
            'CN' => __('China', 'mailoptin'),
            'CX' => __('Christmas Island', 'mailoptin'),
            'CC' => __('Cocos (Keeling) Islands', 'mailoptin'),
            'CO' => __('Colombia', 'mailoptin'),
            'KM' => __('Comoros', 'mailoptin'),
            'CG' => __('Congo (Brazzaville)', 'mailoptin'),
            'CD' => __('Congo (Kinshasa)', 'mailoptin'),
            'CK' => __('Cook Islands', 'mailoptin'),
            'CR' => __('Costa Rica', 'mailoptin'),
            'HR' => __('Croatia', 'mailoptin'),
            'CU' => __('Cuba', 'mailoptin'),
            'CW' => __('Cura&ccedil;ao', 'mailoptin'),
            'CY' => __('Cyprus', 'mailoptin'),
            'CZ' => __('Czech Republic', 'mailoptin'),
            'DK' => __('Denmark', 'mailoptin'),
            'DJ' => __('Djibouti', 'mailoptin'),
            'DM' => __('Dominica', 'mailoptin'),
            'DO' => __('Dominican Republic', 'mailoptin'),
            'EC' => __('Ecuador', 'mailoptin'),
            'EG' => __('Egypt', 'mailoptin'),
            'SV' => __('El Salvador', 'mailoptin'),
            'GQ' => __('Equatorial Guinea', 'mailoptin'),
            'ER' => __('Eritrea', 'mailoptin'),
            'EE' => __('Estonia', 'mailoptin'),
            'SZ' => __('Eswatini', 'mailoptin'),
            'ET' => __('Ethiopia', 'mailoptin'),
            'FK' => __('Falkland Islands', 'mailoptin'),
            'FO' => __('Faroe Islands', 'mailoptin'),
            'FJ' => __('Fiji', 'mailoptin'),
            'FI' => __('Finland', 'mailoptin'),
            'FR' => __('France', 'mailoptin'),
            'GF' => __('French Guiana', 'mailoptin'),
            'PF' => __('French Polynesia', 'mailoptin'),
            'TF' => __('French Southern Territories', 'mailoptin'),
            'GA' => __('Gabon', 'mailoptin'),
            'GM' => __('Gambia', 'mailoptin'),
            'GE' => __('Georgia', 'mailoptin'),
            'DE' => __('Germany', 'mailoptin'),
            'GH' => __('Ghana', 'mailoptin'),
            'GI' => __('Gibraltar', 'mailoptin'),
            'GR' => __('Greece', 'mailoptin'),
            'GL' => __('Greenland', 'mailoptin'),
            'GD' => __('Grenada', 'mailoptin'),
            'GP' => __('Guadeloupe', 'mailoptin'),
            'GU' => __('Guam', 'mailoptin'),
            'GT' => __('Guatemala', 'mailoptin'),
            'GG' => __('Guernsey', 'mailoptin'),
            'GN' => __('Guinea', 'mailoptin'),
            'GW' => __('Guinea-Bissau', 'mailoptin'),
            'GY' => __('Guyana', 'mailoptin'),
            'HT' => __('Haiti', 'mailoptin'),
            'HM' => __('Heard Island and McDonald Islands', 'mailoptin'),
            'HN' => __('Honduras', 'mailoptin'),
            'HK' => __('Hong Kong', 'mailoptin'),
            'HU' => __('Hungary', 'mailoptin'),
            'IS' => __('Iceland', 'mailoptin'),
            'IN' => __('India', 'mailoptin'),
            'ID' => __('Indonesia', 'mailoptin'),
            'IR' => __('Iran', 'mailoptin'),
            'IQ' => __('Iraq', 'mailoptin'),
            'IE' => __('Ireland', 'mailoptin'),
            'IM' => __('Isle of Man', 'mailoptin'),
            'IL' => __('Israel', 'mailoptin'),
            'IT' => __('Italy', 'mailoptin'),
            'CI' => __('Ivory Coast', 'mailoptin'),
            'JM' => __('Jamaica', 'mailoptin'),
            'JP' => __('Japan', 'mailoptin'),
            'JE' => __('Jersey', 'mailoptin'),
            'JO' => __('Jordan', 'mailoptin'),
            'KZ' => __('Kazakhstan', 'mailoptin'),
            'KE' => __('Kenya', 'mailoptin'),
            'KI' => __('Kiribati', 'mailoptin'),
            'KW' => __('Kuwait', 'mailoptin'),
            'KG' => __('Kyrgyzstan', 'mailoptin'),
            'LA' => __('Laos', 'mailoptin'),
            'LV' => __('Latvia', 'mailoptin'),
            'LB' => __('Lebanon', 'mailoptin'),
            'LS' => __('Lesotho', 'mailoptin'),
            'LR' => __('Liberia', 'mailoptin'),
            'LY' => __('Libya', 'mailoptin'),
            'LI' => __('Liechtenstein', 'mailoptin'),
            'LT' => __('Lithuania', 'mailoptin'),
            'LU' => __('Luxembourg', 'mailoptin'),
            'MO' => __('Macao', 'mailoptin'),
            'MK' => __('North Macedonia', 'mailoptin'),
            'MG' => __('Madagascar', 'mailoptin'),
            'MW' => __('Malawi', 'mailoptin'),
            'MY' => __('Malaysia', 'mailoptin'),
            'MV' => __('Maldives', 'mailoptin'),
            'ML' => __('Mali', 'mailoptin'),
            'MT' => __('Malta', 'mailoptin'),
            'MH' => __('Marshall Islands', 'mailoptin'),
            'MQ' => __('Martinique', 'mailoptin'),
            'MR' => __('Mauritania', 'mailoptin'),
            'MU' => __('Mauritius', 'mailoptin'),
            'YT' => __('Mayotte', 'mailoptin'),
            'MX' => __('Mexico', 'mailoptin'),
            'FM' => __('Micronesia', 'mailoptin'),
            'MD' => __('Moldova', 'mailoptin'),
            'MC' => __('Monaco', 'mailoptin'),
            'MN' => __('Mongolia', 'mailoptin'),
            'ME' => __('Montenegro', 'mailoptin'),
            'MS' => __('Montserrat', 'mailoptin'),
            'MA' => __('Morocco', 'mailoptin'),
            'MZ' => __('Mozambique', 'mailoptin'),
            'MM' => __('Myanmar', 'mailoptin'),
            'NA' => __('Namibia', 'mailoptin'),
            'NR' => __('Nauru', 'mailoptin'),
            'NP' => __('Nepal', 'mailoptin'),
            'NL' => __('Netherlands', 'mailoptin'),
            'NC' => __('New Caledonia', 'mailoptin'),
            'NZ' => __('New Zealand', 'mailoptin'),
            'NI' => __('Nicaragua', 'mailoptin'),
            'NE' => __('Niger', 'mailoptin'),
            'NG' => __('Nigeria', 'mailoptin'),
            'NU' => __('Niue', 'mailoptin'),
            'NF' => __('Norfolk Island', 'mailoptin'),
            'MP' => __('Northern Mariana Islands', 'mailoptin'),
            'KP' => __('North Korea', 'mailoptin'),
            'NO' => __('Norway', 'mailoptin'),
            'OM' => __('Oman', 'mailoptin'),
            'PK' => __('Pakistan', 'mailoptin'),
            'PS' => __('Palestinian Territory', 'mailoptin'),
            'PA' => __('Panama', 'mailoptin'),
            'PG' => __('Papua New Guinea', 'mailoptin'),
            'PY' => __('Paraguay', 'mailoptin'),
            'PE' => __('Peru', 'mailoptin'),
            'PH' => __('Philippines', 'mailoptin'),
            'PN' => __('Pitcairn', 'mailoptin'),
            'PL' => __('Poland', 'mailoptin'),
            'PT' => __('Portugal', 'mailoptin'),
            'PR' => __('Puerto Rico', 'mailoptin'),
            'QA' => __('Qatar', 'mailoptin'),
            'RE' => __('Reunion', 'mailoptin'),
            'RO' => __('Romania', 'mailoptin'),
            'RU' => __('Russia', 'mailoptin'),
            'RW' => __('Rwanda', 'mailoptin'),
            'BL' => __('Saint Barth&eacute;lemy', 'mailoptin'),
            'SH' => __('Saint Helena', 'mailoptin'),
            'KN' => __('Saint Kitts and Nevis', 'mailoptin'),
            'LC' => __('Saint Lucia', 'mailoptin'),
            'MF' => __('Saint Martin (French part)', 'mailoptin'),
            'SX' => __('Sint Maarten (Dutch part)', 'mailoptin'),
            'PM' => __('Saint Pierre and Miquelon', 'mailoptin'),
            'VC' => __('Saint Vincent and the Grenadines', 'mailoptin'),
            'SM' => __('San Marino', 'mailoptin'),
            'ST' => __('S&atilde;o Tom&eacute; and Pr&iacute;ncipe', 'mailoptin'),
            'SA' => __('Saudi Arabia', 'mailoptin'),
            'SN' => __('Senegal', 'mailoptin'),
            'RS' => __('Serbia', 'mailoptin'),
            'SC' => __('Seychelles', 'mailoptin'),
            'SL' => __('Sierra Leone', 'mailoptin'),
            'SG' => __('Singapore', 'mailoptin'),
            'SK' => __('Slovakia', 'mailoptin'),
            'SI' => __('Slovenia', 'mailoptin'),
            'SB' => __('Solomon Islands', 'mailoptin'),
            'SO' => __('Somalia', 'mailoptin'),
            'ZA' => __('South Africa', 'mailoptin'),
            'GS' => __('South Georgia/Sandwich Islands', 'mailoptin'),
            'KR' => __('South Korea', 'mailoptin'),
            'SS' => __('South Sudan', 'mailoptin'),
            'ES' => __('Spain', 'mailoptin'),
            'LK' => __('Sri Lanka', 'mailoptin'),
            'SD' => __('Sudan', 'mailoptin'),
            'SR' => __('Suriname', 'mailoptin'),
            'SJ' => __('Svalbard and Jan Mayen', 'mailoptin'),
            'SZ' => __('Swaziland', 'mailoptin'),
            'SE' => __('Sweden', 'mailoptin'),
            'CH' => __('Switzerland', 'mailoptin'),
            'SY' => __('Syria', 'mailoptin'),
            'TW' => __('Taiwan', 'mailoptin'),
            'TJ' => __('Tajikistan', 'mailoptin'),
            'TZ' => __('Tanzania', 'mailoptin'),
            'TH' => __('Thailand', 'mailoptin'),
            'TL' => __('Timor-Leste', 'mailoptin'),
            'TG' => __('Togo', 'mailoptin'),
            'TK' => __('Tokelau', 'mailoptin'),
            'TO' => __('Tonga', 'mailoptin'),
            'TT' => __('Trinidad and Tobago', 'mailoptin'),
            'TN' => __('Tunisia', 'mailoptin'),
            'TR' => __('Turkey', 'mailoptin'),
            'TM' => __('Turkmenistan', 'mailoptin'),
            'TC' => __('Turks and Caicos Islands', 'mailoptin'),
            'TV' => __('Tuvalu', 'mailoptin'),
            'UG' => __('Uganda', 'mailoptin'),
            'UA' => __('Ukraine', 'mailoptin'),
            'AE' => __('United Arab Emirates', 'mailoptin'),
            'GB' => __('United Kingdom (UK)', 'mailoptin'),
            'US' => __('United States (US)', 'mailoptin'),
            'UM' => __('United States (US) Minor Outlying Islands', 'mailoptin'),
            'UY' => __('Uruguay', 'mailoptin'),
            'UZ' => __('Uzbekistan', 'mailoptin'),
            'VU' => __('Vanuatu', 'mailoptin'),
            'VA' => __('Vatican', 'mailoptin'),
            'VE' => __('Venezuela', 'mailoptin'),
            'VN' => __('Vietnam', 'mailoptin'),
            'VG' => __('Virgin Islands (British)', 'mailoptin'),
            'VI' => __('Virgin Islands (US)', 'mailoptin'),
            'WF' => __('Wallis and Futuna', 'mailoptin'),
            'EH' => __('Western Sahara', 'mailoptin'),
            'WS' => __('Samoa', 'mailoptin'),
            'YE' => __('Yemen', 'mailoptin'),
            'ZM' => __('Zambia', 'mailoptin'),
            'ZW' => __('Zimbabwe', 'mailoptin'),
        );
}
